<template>
  <div class="calculator">
    <calculator-monitor
      :result="result"
      :current-operation="currentOperation"
    />

    <div class="calculator__operations" ref="operationsDiv">
      <calculator-button
        v-for="button in BUTTONS"
        :key="button.name"
        :type="button.type"
        :text="button.value"
        @v-click="handleClick(button)"
      />
    </div>
  </div>
</template>

<script>
import { ref, onMounted, onUnmounted } from 'vue';

import { BUTTONS } from '@/data';

import CalculatorMonitor from '@/components/Calculator/CalculatorMonitor.vue';
import CalculatorButton from '@/components/Calculator/CalculatorButton.vue';

export default {
  name: 'HelloWorld',
  components: { CalculatorButton, CalculatorMonitor },
  props: {
    msg: String,
  },
  setup() {
    const result = ref(null);
    const currentOperation = ref('');

    const handleClearButton = () => {
      result.value = null;
      currentOperation.value = '';
    };

    const handleDeleteButton = () => {
      if (!result.value) {
        currentOperation.value = currentOperation.value.slice(0, -1);
      }
    };

    const handleOperandButton = (button) => {
      if (result.value) {
        currentOperation.value = result.value + button.value;
        result.value = null;
      } else {
        const isDigit = /^\d*(\.\d+)?$/;
        const isLastDigit = currentOperation.value.length === 0
          || currentOperation.value[currentOperation.value.length - 1].match(isDigit);

        if (isLastDigit) {
          currentOperation.value += button.value;
        } else {
          currentOperation.value = (
            currentOperation.value.substring(0, currentOperation.value.length - 1) + button.value
          );
        }
      }
    };

    const handleDotButton = (button) => {
      if (result.value) {
        currentOperation.value = result.value;
        result.value = null;
      }
      const isDigit = /^\d*(\.\d+)?$/;
      const isLastDigit = currentOperation.value.length === 0
        || currentOperation.value[currentOperation.value.length - 1].match(isDigit);

      if (isLastDigit) {
        currentOperation.value += button.value;
      }
    };

    const handleNumberButton = (button) => {
      if (result.value) {
        result.value = null;
        currentOperation.value = '';
      }
      currentOperation.value += button.value;
    };

    const handleEqualButton = () => {
      // eslint-disable-next-line no-eval
      result.value = eval(currentOperation.value);
    };

    const handleClick = (button) => {
      if (button.type === 'clear') {
        handleClearButton();
      }

      if (button.name === 'delete') {
        handleDeleteButton();
      }

      if (button.type === 'operand') {
        handleOperandButton(button);
      }

      if (button.type === 'dot') {
        handleDotButton(button);
      }

      if (button.type === 'number') {
        handleNumberButton(button);
      }

      if (button.type === 'equal') {
        handleEqualButton();
      }
    };

    const onKeyUp = (e) => {
      let key;
      if (e.key === 'Enter') {
        key = '=';
      } else if (e.key === 'Backspace') {
        key = 'delete';
      } else {
        key = e.key;
      }
      const foundButton = BUTTONS.find((button) => button.value === key || button.name === key);
      if (foundButton) {
        handleClick(foundButton);
      }
    };

    onMounted(() => {
      document.addEventListener('keyup', onKeyUp);
    });

    onUnmounted(() => {
      document.removeEventListener('keyup', onKeyUp);
    });

    return {
      BUTTONS,
      currentOperation,
      result,
      handleClick,
    };
  },
};
</script>

<style lang="scss">
.calculator {
  display: flex;
  flex-direction: column;
  width: 100%;
  height: 100%;

  @media screen and (min-width: $calculatorWidth) {
    box-shadow: 0 0 10px rgba(0,0,0,0.5);
  }
}

.calculator__operations {
  display: grid;
  height: 55%;
  padding: 16px;
  background-color: var(--main-color);
  grid-template: repeat(5, 1fr) / repeat(4, 1fr);
  gap: 12px;

  @media screen and (min-width: $calculatorWidth) {
    height: 70%;
  }
}
</style>
